# TNL Code of Conduct

The TNL project welcomes and encourages participation by everyone. Therefore, we have adopted this
code of conduct in order to create an open and welcoming environment for everyone, regardless of
age, body size, disability, ethnicity, gender, level of experience, education, nationality, race,
religion, or sexual identity and orientation. No matter how you identify yourself or how others
perceive you, you are welcome in our community.

## Our standards

1. __Be respectful.__

   Disagreements are inevitable among people in a large and diverse community. Remain respectful of
   differing viewpoints and experiences. Disagreement is no excuse for poor behaviour or personal
   attacks.

2. __Assume good faith.__

   There are many ways to reach the goal of the project, which may differ from your ways. Assume
   that other people are working towards this goal. Keep in mind that the people you communicate
   with may not be native English speakers or may have different cultural backgrounds. Be careful
   in the words that you choose to avoid conflicts and misapprehension.

3. __Be inquisitive.__

   TNL is a large and complex project where nobody knows everything. It is always good to ask
   questions early to avoid problems later. Similarly, offers for help are equally important.

4. __Be collaborative.__

   TNL is built on the work done in other projects and it is in turn used by further projects. When
   you contribute to TNL, be willing to explain to others how it works, so that they can build on
   your work to make it even better.

5. __Try to be concise.__

   Keep in mind that what you write once will be read by many other persons. Try to use a clear and
   concise language, especially when a long explanation is necessary. Try to stay on topic, so that
   the whole discussion can be followed as efficiently as possible.

## In case of problems

While this code of conduct should be adhered to by participants, we recognize that sometimes people
may have a bad day, or be unaware of some of the guidelines in this code of conduct. When that
happens, you may reply to them and point out this code of conduct. However, it should still adhere
to the relevant parts of this code of conduct; in particular, it should not be abusive or
disrespectful. Assume good faith; it is more likely that participants are unaware of their bad
behaviour than that they intentionally try to degrade the quality of the discussion.

Serious or persistent offenders will be temporarily or permanently banned from participating in the
TNL community. Complaints should be made to the maintainers of the TNL project. To find contact
information for these administrators, please see the [project's website](https://tnl-project.org/).

## Attribution

This document has been adapted from several sources, notably the
[Debian Code of Conduct version 1.0](https://www.debian.org/code_of_conduct)
and the [SciPy Code of Conduct](https://scipy.github.io/devdocs/dev/conduct/code_of_conduct.html).
